Index: gnu/usr.bin/perl/pod/perl.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perl.pod,v
retrieving revision 1.25
diff -u -p -r1.25 perl.pod
--- gnu/usr.bin/perl/pod/perl.pod	14 Aug 2017 13:50:32 -0000	1.25
+++ gnu/usr.bin/perl/pod/perl.pod	14 Sep 2017 02:23:07 -0000
@@ -180,8 +180,10 @@ aux c2ph h2ph h2xs perlbug pl2pm pod2htm
 
     perlhist		Perl history records
     perldelta		Perl changes since previous version
+    perl5242delta	Perl changes in version 5.24.2
     perl5241delta	Perl changes in version 5.24.1
     perl5240delta	Perl changes in version 5.24.0
+    perl5224delta	Perl changes in version 5.22.4
     perl5223delta	Perl changes in version 5.22.3
     perl5222delta	Perl changes in version 5.22.2
     perl5221delta	Perl changes in version 5.22.1
Index: gnu/usr.bin/perl/pod/perldelta.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perldelta.pod,v
retrieving revision 1.16
diff -u -p -r1.16 perldelta.pod
--- gnu/usr.bin/perl/pod/perldelta.pod	14 Aug 2017 13:48:47 -0000	1.16
+++ gnu/usr.bin/perl/pod/perldelta.pod	14 Sep 2017 02:23:10 -0000
@@ -2,34 +2,43 @@
 
 =head1 NAME
 
-perldelta - what is new for perl v5.24.2
+perldelta - what is new for perl v5.24.3
 
 =head1 DESCRIPTION
 
-This document describes differences between the 5.24.1 release and the 5.24.2
+This document describes differences between the 5.24.2 release and the 5.24.3
 release.
 
-If you are upgrading from an earlier release such as 5.24.0, first read
-L<perl5241delta>, which describes differences between 5.24.0 and 5.24.1.
+If you are upgrading from an earlier release such as 5.24.1, first read
+L<perl5242delta>, which describes differences between 5.24.1 and 5.24.2.
 
 =head1 Security
 
-=head2 Improved handling of '.' in @INC in base.pm
+=head2 [CVE-2017-12837] Heap buffer overflow in regular expression compiler
 
-The handling of (the removal of) C<'.'> in C<@INC> in L<base> has been
-improved.  This resolves some problematic behaviour in the approach taken in
-Perl 5.24.1, which is probably best described in the following two threads on
-the Perl 5 Porters mailing list:
-L<http://www.nntp.perl.org/group/perl.perl5.porters/2016/08/msg238991.html>,
-L<http://www.nntp.perl.org/group/perl.perl5.porters/2016/10/msg240297.html>.
-
-=head2 "Escaped" colons and relative paths in PATH
-
-On Unix systems, Perl treats any relative paths in the PATH environment
-variable as tainted when starting a new process.  Previously, it was allowing a
-backslash to escape a colon (unlike the OS), consequently allowing relative
-paths to be considered safe if the PATH was set to something like C</\:.>.  The
-check has been fixed to treat C<.> as tainted in that example.
+Compiling certain regular expression patterns with the case-insensitive
+modifier could cause a heap buffer overflow and crash perl.  This has now been
+fixed.
+L<[perl #131582]|https://rt.perl.org/Public/Bug/Display.html?id=131582>
+
+=head2 [CVE-2017-12883] Buffer over-read in regular expression parser
+
+For certain types of syntax error in a regular expression pattern, the error
+message could either contain the contents of a random, possibly large, chunk of
+memory, or could crash perl.  This has now been fixed.
+L<[perl #131598]|https://rt.perl.org/Public/Bug/Display.html?id=131598>
+
+=head2 [CVE-2017-12814] C<$ENV{$key}> stack buffer overflow on Windows
+
+A possible stack buffer overflow in the C<%ENV> code on Windows has been fixed
+by removing the buffer completely since it was superfluous anyway.
+L<[perl #131665]|https://rt.perl.org/Public/Bug/Display.html?id=131665>
+
+=head1 Incompatible Changes
+
+There are no changes intentionally incompatible with 5.24.2.  If any exist,
+they are bugs, and we request that you submit a report.  See L</Reporting
+Bugs> below.
 
 =head1 Modules and Pragmata
 
@@ -39,11 +48,83 @@ check has been fixed to treat C<.> as ta
 
 =item *
 
-L<base> has been upgraded from version 2.23 to 2.23_01.
+L<Module::CoreList> has been upgraded from version 5.20170715_24 to
+5.20170922_24.
+
+=item *
+
+L<POSIX> has been upgraded from version 1.65 to 1.65_01.
+
+=item *
+
+L<Time::HiRes> has been upgraded from version 1.9733 to 1.9741.
+
+L<[perl #128427]|https://rt.perl.org/Public/Bug/Display.html?id=128427>
+L<[perl #128445]|https://rt.perl.org/Public/Bug/Display.html?id=128445>
+L<[perl #128972]|https://rt.perl.org/Public/Bug/Display.html?id=128972>
+L<[cpan #120032]|https://rt.cpan.org/Public/Bug/Display.html?id=120032>
+
+=back
+
+=head1 Configuration and Compilation
+
+=over 4
+
+=item *
+
+When building with GCC 6 and link-time optimization (the B<-flto> option to
+B<gcc>), F<Configure> was treating all probed symbols as present on the system,
+regardless of whether they actually exist.  This has been fixed.
+L<[perl #128131]|https://rt.perl.org/Public/Bug/Display.html?id=128131>
+
+=item *
+
+F<Configure> now aborts if both C<-Duselongdouble> and C<-Dusequadmath> are
+requested.
+L<[perl #126203]|https://rt.perl.org/Public/Bug/Display.html?id=126203>
+
+=item *
+
+Fixed a bug in which F<Configure> could append C<-quadmath> to the archname
+even if it was already present.
+L<[perl #128538]|https://rt.perl.org/Public/Bug/Display.html?id=128538>
 
 =item *
 
-L<Module::CoreList> has been upgraded from version 5.20170114_24 to 5.20170715_24.
+Clang builds with C<-DPERL_GLOBAL_STRUCT> or C<-DPERL_GLOBAL_STRUCT_PRIVATE>
+have been fixed (by disabling Thread Safety Analysis for these configurations).
+
+=back
+
+=head1 Platform Support
+
+=head2 Platform-Specific Notes
+
+=over 4
+
+=item VMS
+
+=over 4
+
+=item *
+
+C<configure.com> now recognizes the VSI-branded C compiler.
+
+=back
+
+=item Windows
+
+=over 4
+
+=item *
+
+Building XS modules with GCC 6 in a 64-bit build of Perl failed due to
+incorrect mapping of C<strtoll> and C<strtoull>.  This has now been fixed.
+L<[perl #131726]|https://rt.perl.org/Public/Bug/Display.html?id=131726>
+L<[cpan #121683]|https://rt.cpan.org/Public/Bug/Display.html?id=121683>
+L<[cpan #122353]|https://rt.cpan.org/Public/Bug/Display.html?id=122353>
+
+=back
 
 =back
 
@@ -53,29 +134,162 @@ L<Module::CoreList> has been upgraded fr
 
 =item *
 
-Fixed a crash with C<s///l> where it thought it was dealing with UTF-8 when it
-wasn't.
-L<[perl #129038]|https://rt.perl.org/Ticket/Display.html?id=129038>
+C<< /@0{0*-E<gt>@*/*0 >> and similar contortions used to crash, but no longer
+do, but merely produce a syntax error.
+L<[perl #128171]|https://rt.perl.org/Public/Bug/Display.html?id=128171>
+
+=item *
+
+C<do> or C<require> with an argument which is a reference or typeglob which,
+when stringified, contains a null character, started crashing in Perl 5.20, but
+has now been fixed.
+L<[perl #128182]|https://rt.perl.org/Public/Bug/Display.html?id=128182>
+
+=item *
+
+Expressions containing an C<&&> or C<||> operator (or their synonyms C<and> and
+C<or>) were being compiled incorrectly in some cases.  If the left-hand side
+consisted of either a negated bareword constant or a negated C<do {}> block
+containing a constant expression, and the right-hand side consisted of a
+negated non-foldable expression, one of the negations was effectively ignored.
+The same was true of C<if> and C<unless> statement modifiers, though with the
+left-hand and right-hand sides swapped.  This long-standing bug has now been
+fixed.
+L<[perl #127952]|https://rt.perl.org/Public/Bug/Display.html?id=127952>
+
+=item *
+
+C<reset> with an argument no longer crashes when encountering stash entries
+other than globs.
+L<[perl #128106]|https://rt.perl.org/Public/Bug/Display.html?id=128106>
+
+=item *
+
+Assignment of hashes to, and deletion of, typeglobs named C<*::::::> no longer
+causes crashes.
+L<[perl #128086]|https://rt.perl.org/Public/Bug/Display.html?id=128086>
+
+=item *
+
+Assignment variants of any bitwise ops under the C<bitwise> feature would crash
+if the left-hand side was an array or hash.
+L<[perl #128204]|https://rt.perl.org/Public/Bug/Display.html?id=128204>
+
+=item *
+
+C<socket> now leaves the error code returned by the system in C<$!> on failure.
+L<[perl #128316]|https://rt.perl.org/Public/Bug/Display.html?id=128316>
+
+=item *
+
+Parsing bad POSIX charclasses no longer leaks memory.
+L<[perl #128313]|https://rt.perl.org/Public/Bug/Display.html?id=128313>
+
+=item *
+
+Since Perl 5.20, line numbers have been off by one when perl is invoked with
+the B<-x> switch.  This has been fixed.
+L<[perl #128508]|https://rt.perl.org/Public/Bug/Display.html?id=128508>
+
+=item *
+
+Some obscure cases of subroutines and file handles being freed at the same time
+could result in crashes, but have been fixed.  The crash was introduced in Perl
+5.22.
+L<[perl #128597]|https://rt.perl.org/Public/Bug/Display.html?id=128597>
+
+=item *
+
+Some regular expression parsing glitches could lead to assertion failures with
+regular expressions such as C</(?E<lt>=/> and C</(?E<lt>!/>.  This has now been
+fixed.
+L<[perl #128170]|https://rt.perl.org/Public/Bug/Display.html?id=128170>
+
+=item *
+
+C<gethostent> and similar functions now perform a null check internally, to
+avoid crashing with the torsocks library.  This was a regression from Perl
+5.22.
+L<[perl #128740]|https://rt.perl.org/Public/Bug/Display.html?id=128740>
+
+=item *
+
+Mentioning the same constant twice in a row (which is a syntax error) no longer
+fails an assertion under debugging builds.  This was a regression from Perl
+5.20.
+L<[perl #126482]|https://rt.perl.org/Public/Bug/Display.html?id=126482>
+
+=item *
+
+In Perl 5.24 C<fchown> was changed not to accept negative one as an argument
+because in some platforms that is an error.  However, in some other platforms
+that is an acceptable argument.  This change has been reverted.
+L<[perl #128967]|https://rt.perl.org/Public/Bug/Display.html?id=128967>.
+
+=item *
+
+C<@{x> followed by a newline where C<"x"> represents a control or non-ASCII
+character no longer produces a garbled syntax error message or a crash.
+L<[perl #128951]|https://rt.perl.org/Public/Bug/Display.html?id=128951>
+
+=item *
+
+A regression in Perl 5.24 with C<tr/\N{U+...}/foo/> when the code point was
+between 128 and 255 has been fixed.
+L<[perl #128734]|https://rt.perl.org/Public/Bug/Display.html?id=128734>.
+
+=item *
+
+Many issues relating to C<printf "%a"> of hexadecimal floating point were
+fixed.  In addition, the "subnormals" (formerly known as "denormals") floating
+point numbers are now supported both with the plain IEEE 754 floating point
+numbers (64-bit or 128-bit) and the x86 80-bit "extended precision".  Note that
+subnormal hexadecimal floating point literals will give a warning about
+"exponent underflow".
+L<[perl #128843]|https://rt.perl.org/Public/Bug/Display.html?id=128843>
+L<[perl #128888]|https://rt.perl.org/Public/Bug/Display.html?id=128888>
+L<[perl #128889]|https://rt.perl.org/Public/Bug/Display.html?id=128889>
+L<[perl #128890]|https://rt.perl.org/Public/Bug/Display.html?id=128890>
+L<[perl #128893]|https://rt.perl.org/Public/Bug/Display.html?id=128893>
+L<[perl #128909]|https://rt.perl.org/Public/Bug/Display.html?id=128909>
+L<[perl #128919]|https://rt.perl.org/Public/Bug/Display.html?id=128919>
+
+=item *
+
+The parser could sometimes crash if a bareword came after C<evalbytes>.
+L<[perl #129196]|https://rt.perl.org/Public/Bug/Display.html?id=129196>
+
+=item *
+
+Fixed a place where the regex parser was not setting the syntax error correctly
+on a syntactically incorrect pattern.
+L<[perl #129122]|https://rt.perl.org/Public/Bug/Display.html?id=129122>
+
+=item *
+
+A vulnerability in Perl's C<sprintf> implementation has been fixed by avoiding
+a possible memory wrap.
+L<[perl #131260]|https://rt.perl.org/Public/Bug/Display.html?id=131260>
 
 =back
 
 =head1 Acknowledgements
 
-Perl 5.24.2 represents approximately 6 months of development since Perl 5.24.1
-and contains approximately 2,500 lines of changes across 53 files from 18
+Perl 5.24.3 represents approximately 2 months of development since Perl 5.24.2
+and contains approximately 3,100 lines of changes across 120 files from 20
 authors.
 
 Excluding auto-generated files, documentation and release tools, there were
-approximately 960 lines of changes to 17 .pm, .t, .c and .h files.
+approximately 1,500 lines of changes to 56 .pm, .t, .c and .h files.
 
 Perl continues to flourish into its third decade thanks to a vibrant community
 of users and developers.  The following people are known to have contributed
-the improvements that became Perl 5.24.2:
+the improvements that became Perl 5.24.3:
 
-Aaron Crane, Abigail, Aristotle Pagaltzis, Chris 'BinGOs' Williams, Dan
-Collins, David Mitchell, Eric Herman, Father Chrysostomos, James E Keenan, Karl
-Williamson, Lukas Mai, Renee Baecker, Ricardo Signes, Sawyer X, Stevan Little,
-Steve Hay, Tony Cook, Yves Orton.
+Aaron Crane, Craig A. Berry, Dan Collins, Daniel Dragan, Dave Cross, David
+Mitchell, Eric Herman, Father Chrysostomos, H.Merijn Brand, Hugo van der
+Sanden, James E Keenan, Jarkko Hietaniemi, Karl Williamson, Lukas Mai, Matthew
+Horsfall, Stevan Little, Steve Hay, Steven Humphrey, Tony Cook, Yves Orton.
 
 The list above is almost certainly incomplete as it is automatically generated
 from version control history.  In particular, it does not include the names of
@@ -103,8 +317,8 @@ will be sent off to perlbug@perl.org to 
 
 If the bug you are reporting has security implications which make it
 inappropriate to send to a publicly archived mailing list, then see
-L<perlsec/SECURITY VULNERABILITY CONTACT INFORMATION>
-for details of how to report the issue.
+L<perlsec/SECURITY VULNERABILITY CONTACT INFORMATION> for details of how to
+report the issue.
 
 =head1 SEE ALSO
 
Index: gnu/usr.bin/perl/pod/perldiag.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perldiag.pod,v
retrieving revision 1.19
diff -u -p -r1.19 perldiag.pod
--- gnu/usr.bin/perl/pod/perldiag.pod	5 Feb 2017 00:32:18 -0000	1.19
+++ gnu/usr.bin/perl/pod/perldiag.pod	14 Sep 2017 02:23:11 -0000
@@ -2479,7 +2479,9 @@ than the floating point supports.
 =item Hexadecimal float: exponent underflow
 
 (W overflow) The hexadecimal floating point has a smaller exponent
-than the floating point supports.
+than the floating point supports.  With the IEEE 754 floating point,
+this may also mean that the subnormals (formerly known as denormals)
+are being used, which may or may not be an error.
 
 =item Hexadecimal float: internal error (%s)
 
Index: gnu/usr.bin/perl/pod/perlfunc.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perlfunc.pod,v
retrieving revision 1.21
diff -u -p -r1.21 perlfunc.pod
--- gnu/usr.bin/perl/pod/perlfunc.pod	5 Feb 2017 00:32:18 -0000	1.21
+++ gnu/usr.bin/perl/pod/perlfunc.pod	14 Sep 2017 02:23:12 -0000
@@ -1703,8 +1703,8 @@ produce, respectively
     /etc/games is no good, stopped at canasta line 123.
 
 If the output is empty and L<C<$@>|perlvar/$@> already contains a value
-(typically from a previous eval) that value is reused after appending
-C<"\t...propagated">.  This is useful for propagating exceptions:
+(typically from a previous L<C<eval>|/eval EXPR>) that value is reused after
+appending C<"\t...propagated">.  This is useful for propagating exceptions:
 
     eval { ... };
     die unless $@ =~ /Expected exception/;
@@ -4006,8 +4006,8 @@ Note that L<C<$_>|perlvar/$_> is an alia
 be used to modify the elements of the LIST.  While this is useful and
 supported, it can cause bizarre results if the elements of LIST are not
 variables.  Using a regular C<foreach> loop for this purpose would be
-clearer in most cases.  See also L<C<grep>|/grep BLOCK LIST> for an
-array composed of those items of the original list for which the BLOCK
+clearer in most cases.  See also L<C<grep>|/grep BLOCK LIST> for a
+list composed of those items of the original list for which the BLOCK
 or EXPR evaluates to true.
 
 C<{> starts both hash references and blocks, so C<map { ...> could be either
Index: gnu/usr.bin/perl/pod/perlhist.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perlhist.pod,v
retrieving revision 1.20
diff -u -p -r1.20 perlhist.pod
--- gnu/usr.bin/perl/pod/perlhist.pod	14 Aug 2017 13:48:47 -0000	1.20
+++ gnu/usr.bin/perl/pod/perlhist.pod	14 Sep 2017 02:23:12 -0000
@@ -578,8 +578,8 @@ the strings?).
  Steve     5.22.4       2017-Jul-15
 
  Ricardo   5.23.0       2015-Jun-20     The 5.23 development track
- Matthew   5.23.1       2015-Jul-20
- Matthew   5.23.2       2015-Aug-20
+ Matthew H 5.23.1       2015-Jul-20
+ Matthew H 5.23.2       2015-Aug-20
  Peter     5.23.3       2015-Sep-20
  Steve     5.23.4       2015-Oct-20
  Abigail   5.23.5       2015-Nov-20
@@ -602,10 +602,11 @@ the strings?).
  Steve     5.24.1       2017-Jan-14
  Steve     5.24.2-RC1   2017-Jul-01
  Steve     5.24.2       2017-Jul-15
+ Steve     5.24.3-RC1   2017-Sep-10
 
  Ricardo   5.25.0       2016-May-09     The 5.25 development track
  Sawyer X  5.25.1       2016-May-20
- Matthew   5.25.2       2016-Jun-20
+ Matthew H 5.25.2       2016-Jun-20
  Steve     5.25.3       2016-Jul-20
  BinGOs    5.25.4       2016-Aug-20
  Stevan    5.25.5       2016-Sep-20
@@ -620,9 +621,12 @@ the strings?).
  Sawyer X  5.26.0-RC1   2017-May-11     The 5.26 maintenance track
  Sawyer X  5.26.0-RC2   2017-May-23
  Sawyer X  5.26.0       2017-May-30
+ Steve     5.26.1-RC1   2017-Sep-10
 
  Sawyer X  5.27.0       2017-May-31     The 5.27 development track
  Eric      5.27.1       2017-Jun-20
+ Aaron     5.27.2       2017-Jul-20
+ Matthew H 5.27.3       2017-Aug-21
 
 =head2 SELECTED RELEASE SIZES
 
Index: gnu/usr.bin/perl/pod/perlop.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perlop.pod,v
retrieving revision 1.26
diff -u -p -r1.26 perlop.pod
--- gnu/usr.bin/perl/pod/perlop.pod	14 Aug 2017 13:49:45 -0000	1.26
+++ gnu/usr.bin/perl/pod/perlop.pod	14 Sep 2017 02:23:13 -0000
@@ -2423,7 +2423,7 @@ controls and characters which have no AS
 But, even for portable ranges, it is not generally obvious what is
 included without having to look things up.  A sound principle is to use
 only ranges that begin from and end at either ASCII alphabetics of equal
-case (C<b-e>, C<b-E>), or digits (C<1-4>).  Anything else is unclear
+case (C<b-e>, C<B-E>), or digits (C<1-4>).  Anything else is unclear
 (and unportable unless C<\N{...}> is used).  If in doubt, spell out the
 character sets in full.
 
Index: gnu/usr.bin/perl/pod/perlrecharclass.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perlrecharclass.pod,v
retrieving revision 1.2
diff -u -p -r1.2 perlrecharclass.pod
--- gnu/usr.bin/perl/pod/perlrecharclass.pod	5 Feb 2017 00:32:19 -0000	1.2
+++ gnu/usr.bin/perl/pod/perlrecharclass.pod	14 Sep 2017 02:23:14 -0000
@@ -863,7 +863,7 @@ Same for the two ASCII-only range forms.
 =back
 
 There are various other synonyms that can be used besides the names
-listed in the table.  For example, C<\p{PosixAlpha}> can be written as
+listed in the table.  For example, C<\p{XPosixAlpha}> can be written as
 C<\p{Alpha}>.  All are listed in
 L<perluniprops/Properties accessible through \p{} and \P{}>.
 
Index: gnu/usr.bin/perl/pod/perlrun.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perlrun.pod,v
retrieving revision 1.18
diff -u -p -r1.18 perlrun.pod
--- gnu/usr.bin/perl/pod/perlrun.pod	5 Feb 2017 00:32:19 -0000	1.18
+++ gnu/usr.bin/perl/pod/perlrun.pod	14 Sep 2017 02:23:15 -0000
@@ -345,7 +345,7 @@ You can also use binmode() to set the en
 X<-c>
 
 causes Perl to check the syntax of the program and then exit without
-executing it.  Actually, it I<will> execute and C<BEGIN>, C<UNITCHECK>,
+executing it.  Actually, it I<will> execute any C<BEGIN>, C<UNITCHECK>,
 or C<CHECK> blocks and any C<use> statements: these are considered as
 occurring outside the execution of your program.  C<INIT> and C<END>
 blocks, however, will be skipped.
Index: gnu/usr.bin/perl/pod/perlunicode.pod
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/pod/perlunicode.pod,v
retrieving revision 1.2
diff -u -p -r1.2 perlunicode.pod
--- gnu/usr.bin/perl/pod/perlunicode.pod	5 Feb 2017 00:32:19 -0000	1.2
+++ gnu/usr.bin/perl/pod/perlunicode.pod	14 Sep 2017 02:23:15 -0000
@@ -1827,7 +1827,7 @@ the XS level, and L<perlapi/Unicode Supp
 Perl by default comes with the latest supported Unicode version built-in, but
 the goal is to allow you to change to use any earlier one.  In Perls
 v5.20 and v5.22, however, the earliest usable version is Unicode 5.1.
-Perl v5.18 is able to handle all earlier versions.
+Perl v5.18 and v5.24 are able to handle all earlier versions.
 
 Download the files in the desired version of Unicode from the Unicode web
 site L<http://www.unicode.org>).  These should replace the existing files in
Index: gnu/usr.bin/perl/regen/opcodes
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/regen/opcodes,v
retrieving revision 1.2
diff -u -p -r1.2 opcodes
--- gnu/usr.bin/perl/regen/opcodes	5 Feb 2017 00:32:19 -0000	1.2
+++ gnu/usr.bin/perl/regen/opcodes	14 Sep 2017 02:23:17 -0000
@@ -165,12 +165,12 @@ scmp		string comparison (cmp)	ck_null		i
 bit_and		bitwise and (&)		ck_bitop	fst2	S S|
 bit_xor		bitwise xor (^)		ck_bitop	fst2	S S|
 bit_or		bitwise or (|)		ck_bitop	fst2	S S|
-nbit_and	numeric bitiwse and (&)	ck_bitop	fsT2	S S|
+nbit_and	numeric bitwise and (&)	ck_bitop	fsT2	S S|
 nbit_xor	numeric bitwise xor (^)	ck_bitop	fsT2	S S|
 nbit_or		numeric bitwise or (|)	ck_bitop	fsT2	S S|
-sbit_and	string bitiwse and (&)	ck_bitop	fst2	S S|
-sbit_xor	string bitwise xor (^)	ck_bitop	fst2	S S|
-sbit_or		string bitwise or (|)	ck_bitop	fst2	S S|
+sbit_and	string bitwise and (&.)	ck_bitop	fst2	S S|
+sbit_xor	string bitwise xor (^.)	ck_bitop	fst2	S S|
+sbit_or		string bitwise or (|.)	ck_bitop	fst2	S S|
 
 negate		negation (-)		ck_null		Ifst1	S
 i_negate	integer negation (-)	ck_null		ifst1	S
Index: gnu/usr.bin/perl/regen/warnings.pl
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/regen/warnings.pl,v
retrieving revision 1.2
diff -u -p -r1.2 warnings.pl
--- gnu/usr.bin/perl/regen/warnings.pl	5 Feb 2017 00:32:19 -0000	1.2
+++ gnu/usr.bin/perl/regen/warnings.pl	14 Sep 2017 02:23:17 -0000
@@ -358,8 +358,10 @@ EOM
 
   print $warn <<'EOM';
 
-#define isLEXWARN_on 	cBOOL(PL_curcop->cop_warnings != pWARN_STD)
-#define isLEXWARN_off	cBOOL(PL_curcop->cop_warnings == pWARN_STD)
+#define isLEXWARN_on \
+	cBOOL(PL_curcop && PL_curcop->cop_warnings != pWARN_STD)
+#define isLEXWARN_off \
+	cBOOL(!PL_curcop || PL_curcop->cop_warnings == pWARN_STD)
 #define isWARN_ONCE	(PL_dowarn & (G_WARN_ON|G_WARN_ONCE))
 #define isWARN_on(c,x)	(IsSet((U8 *)(c + 1), 2*(x)))
 #define isWARNf_on(c,x)	(IsSet((U8 *)(c + 1), 2*(x)+1))
Index: gnu/usr.bin/perl/t/base/lex.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/base/lex.t,v
retrieving revision 1.15
diff -u -p -r1.15 lex.t
--- gnu/usr.bin/perl/t/base/lex.t	5 Feb 2017 00:32:19 -0000	1.15
+++ gnu/usr.bin/perl/t/base/lex.t	14 Sep 2017 02:23:18 -0000
@@ -1,6 +1,6 @@
 #!./perl
 
-print "1..104\n";
+print "1..105\n";
 
 $x = 'x';
 
@@ -521,4 +521,10 @@ eval q|s##[}#e|;
  # Used to crash [perl #125350]
  eval ('qq{@{[0}*sub{]]}}}=sub{0' . "\c[");
  print "ok $test - 125350\n"; $test++;
+}
+
+{
+ # Used to crash [perl #128171]
+ eval ('/@0{0*->@*/*]');
+ print "ok $test - 128171\n"; $test++;
 }
Index: gnu/usr.bin/perl/t/io/socket.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/io/socket.t,v
retrieving revision 1.2
diff -u -p -r1.2 socket.t
--- gnu/usr.bin/perl/t/io/socket.t	5 Feb 2017 00:32:19 -0000	1.2
+++ gnu/usr.bin/perl/t/io/socket.t	14 Sep 2017 02:23:18 -0000
@@ -128,6 +128,28 @@ SKIP: {
     }
 }
 
+SKIP:
+{
+    eval { require Errno; defined &Errno::EMFILE }
+      or skip "Can't load Errno or EMFILE not defined", 1;
+    my @socks;
+    my $sock_limit = 1000; # don't consume every file in the system
+    # Default limits on various systems I have:
+    #  65536 - Linux
+    #    256 - Solaris
+    #    128 - NetBSD
+    #    256 - Cygwin
+    #    256 - darwin
+    while (@socks < $sock_limit) {
+        socket my $work, PF_INET, SOCK_STREAM, $tcp
+          or last;
+        push @socks, $work;
+    }
+    @socks == $sock_limit
+      and skip "Didn't run out of open handles", 1;
+    is(0+$!, Errno::EMFILE(), "check correct errno for too many files");
+}
+
 done_testing();
 
 my @child_tests;
Index: gnu/usr.bin/perl/t/lib/croak/op
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/lib/croak/op,v
retrieving revision 1.2
diff -u -p -r1.2 op
--- gnu/usr.bin/perl/t/lib/croak/op	5 Feb 2017 00:32:20 -0000	1.2
+++ gnu/usr.bin/perl/t/lib/croak/op	14 Sep 2017 02:23:18 -0000
@@ -65,6 +65,54 @@ my main $f;
 EXPECT
 No such class field "c" in variable $f of type main at - line 3.
 ########
+# NAME Num-specific &= on @array
+use feature 'bitwise';
+@a &= 1;
+EXPECT
+The bitwise feature is experimental at - line 2.
+Can't modify array dereference in numeric bitwise and (&) at - line 2, near "1;"
+Execution of - aborted due to compilation errors.
+########
+# NAME Num-specific |= on @array
+use feature 'bitwise';
+@a |= 1;
+EXPECT
+The bitwise feature is experimental at - line 2.
+Can't modify array dereference in numeric bitwise or (|) at - line 2, near "1;"
+Execution of - aborted due to compilation errors.
+########
+# NAME Num-specific ^= on @array
+use feature 'bitwise';
+@a ^= 1;
+EXPECT
+The bitwise feature is experimental at - line 2.
+Can't modify array dereference in numeric bitwise xor (^) at - line 2, near "1;"
+Execution of - aborted due to compilation errors.
+########
+# NAME &.= on @array
+use feature 'bitwise';
+@a &.= 1;
+EXPECT
+The bitwise feature is experimental at - line 2.
+Can't modify array dereference in string bitwise and (&.) at - line 2, near "1;"
+Execution of - aborted due to compilation errors.
+########
+# NAME |.= on @array
+use feature 'bitwise';
+@a |.= 1;
+EXPECT
+The bitwise feature is experimental at - line 2.
+Can't modify array dereference in string bitwise or (|.) at - line 2, near "1;"
+Execution of - aborted due to compilation errors.
+########
+# NAME ^.= on @array
+use feature 'bitwise';
+@a ^.= 1;
+EXPECT
+The bitwise feature is experimental at - line 2.
+Can't modify array dereference in string bitwise xor (^.) at - line 2, near "1;"
+Execution of - aborted due to compilation errors.
+########
 # NAME Can't declare conditional
 my($a?$b:$c)
 EXPECT
Index: gnu/usr.bin/perl/t/op/evalbytes.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/evalbytes.t,v
retrieving revision 1.2
diff -u -p -r1.2 evalbytes.t
--- gnu/usr.bin/perl/t/op/evalbytes.t	5 Feb 2017 00:32:20 -0000	1.2
+++ gnu/usr.bin/perl/t/op/evalbytes.t	14 Sep 2017 02:23:20 -0000
@@ -6,7 +6,7 @@ BEGIN {
     require './test.pl'; require './charset_tools.pl';
 }
 
-plan(tests => 8);
+plan(tests => 9);
 
 {
     local $SIG{__WARN__} = sub {};
@@ -33,3 +33,7 @@ chop($upcode = "use utf8; $U_100" . chr 
 is evalbytes $upcode, chr 256, 'use utf8 within evalbytes on utf8 string';
 eval { evalbytes chr 256 };
 like $@, qr/Wide character/, 'evalbytes croaks on non-bytes';
+
+eval 'evalbytes S';
+ok 1, '[RT #129196] evalbytes S should not segfault';
+
Index: gnu/usr.bin/perl/t/op/gv.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/gv.t,v
retrieving revision 1.14
diff -u -p -r1.14 gv.t
--- gnu/usr.bin/perl/t/op/gv.t	5 Feb 2017 00:32:20 -0000	1.14
+++ gnu/usr.bin/perl/t/op/gv.t	14 Sep 2017 02:23:20 -0000
@@ -12,7 +12,7 @@ BEGIN {
 
 use warnings;
 
-plan(tests => 276 );
+plan(tests => 277 );
 
 # type coercion on assignment
 $foo = 'foo';
@@ -1153,6 +1153,22 @@ pass "No crash due to CvGV pointing to g
     is($c_125840, 1, 'RT #125840: $c=$d');
 }
 
+# [perl #128597] Crash when gp_free calls ckWARN_d
+# I am not sure this test even belongs in this file, as the crash was the
+# result of various features interacting.  But a call to ckWARN_d from
+# gv.c:gp_free triggered the crash, so this seems as good a place as any.
+# ‘die’ (or any abnormal scope exit) can cause the current cop to be freed,
+# if the subroutine containing the ‘die’ gets freed as a result.  That
+# causes PL_curcop to be set to NULL.  If a writable handle gets freed
+# while PL_curcop is NULL, then gp_free will call ckWARN_d while that con-
+# dition still holds, so ckWARN_d needs to know about PL_curcop possibly
+# being NULL.
+SKIP: {
+    skip_if_miniperl("No PerlIO::scalar on miniperl", 1);
+    runperl(prog => 'open my $fh, q|>|, \$buf;'
+                   .'my $sub = eval q|sub {exit 0}|; $sub->()');
+    is ($? & 127, 0,"[perl #128597] No crash when gp_free calls ckWARN_d");
+}
 
 __END__
 Perl
Index: gnu/usr.bin/perl/t/op/hexfp.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/hexfp.t,v
retrieving revision 1.1
diff -u -p -r1.1 hexfp.t
--- gnu/usr.bin/perl/t/op/hexfp.t	5 Feb 2017 00:32:20 -0000	1.1
+++ gnu/usr.bin/perl/t/op/hexfp.t	14 Sep 2017 02:23:20 -0000
@@ -10,7 +10,7 @@ use strict;
 
 use Config;
 
-plan(tests => 105);
+plan(tests => 109);
 
 # Test hexfloat literals.
 
@@ -241,6 +241,19 @@ SKIP:
         print "# skipping warning tests\n";
         skip "nv_preserves_uv_bits is $Config{nv_preserves_uv_bits} not 53", 26;
     }
+}
+
+# [perl #128919] limited exponent range in hex fp literal with long double
+SKIP: {
+    skip("non-80-bit-long-double", 4)
+        unless ($Config{uselongdouble} &&
+		($Config{nvsize} == 16 || $Config{nvsize} == 12) &&
+		($Config{longdblkind} == 3 ||
+		 $Config{longdblkind} == 4));
+    is(0x1p-1074,  4.94065645841246544e-324);
+    is(0x1p-1075,  2.47032822920623272e-324, '[perl #128919]');
+    is(0x1p-1076,  1.23516411460311636e-324);
+    is(0x1p-16445, 3.6451995318824746e-4951);
 }
 
 # sprintf %a/%A testing is done in sprintf2.t,
Index: gnu/usr.bin/perl/t/op/lex.t
===================================================================
RCS file: /cvs/src/gnu/usr.bin/perl/t/op/lex.t,v
retrieving revision 1.3
diff -u -p -r1.3 lex.t
--- gnu/usr.bin/perl/t/op/lex.t	5 Feb 2017 00:32:20 -0000	1.3
+++ gnu/usr.bin/perl/t/op/lex.t	14 Sep 2017 02:23:20 -0000
@@ -7,7 +7,7 @@ use warnings;
 
 BEGIN { chdir 't' if -d 't'; require './test.pl'; }
 
-plan(tests => 25);
+plan(tests => 26);
 
 {
     no warnings 'deprecated';
@@ -129,7 +129,7 @@ fresh_perl_is(
   '* <null> ident'
 );
 SKIP: {
-    skip "Different output on EBCDIC (presumably)", 2 if $::IS_EBCDIC;
+    skip "Different output on EBCDIC (presumably)", 3 if $::IS_EBCDIC;
     fresh_perl_is(
       qq'"ab}"ax;&\0z\x8Ao}\x82x;', <<gibberish,
 Bareword found where operator expected at - line 1, near ""ab}"ax"
@@ -149,6 +149,13 @@ Unrecognized character \\x8A; marked by 
 gibberish
        { stderr => 1 },
       'gibberish containing &{+z} - used to crash [perl #123753]'
+    );
+    fresh_perl_is(
+      "\@{\327\n", <<\gibberisi,
+Unrecognized character \xD7; marked by <-- HERE after @{<-- HERE near column 3 at - line 1.
+gibberisi
+       { stderr => 1 },
+      '@ { \327 \n - used to garble output (or fail asan) [perl #128951]'
     );
 }
 
